#include "js-gtk.h"

#define SIMPLE_FUNC(funcname) \
  SIMPLE_WRAPPER_FUNC(container,Container,CONTAINER,funcname)
#define INT_FUNC(funcname) \
  INT_WRAPPER_FUNC(container,Container,CONTAINER,funcname)
#define WIDGET_FUNC(funcname) \
  WIDGET_WRAPPER_FUNC(container,Container,CONTAINER,funcname)

static JSBool container_set_resize_mode(JSContext *cx, JSObject *obj, 
                                  uintN argc, jsval *argv, jsval *rval) {    
  GtkContainer *prefix;                                                         
  GET_GTK(prefix,cx,obj,CONTAINER);                                              
  /* have to make this really use GtkResizeMode */
  gtk_container_set_resize_mode(prefix, 1);                                          
  return JS_TRUE;                                                             
}

/* JG 1999 02 27 */
/*
SIMPLE_FUNC(set_resize_mode)

SIMPLE_FUNC(enable_resize)
SIMPLE_FUNC(block_resize)
SIMPLE_FUNC(unblock_resize)
*/
WIDGET_FUNC(add)
WIDGET_FUNC(remove)
INT_FUNC(set_border_width)
INT_FUNC(focus)

#undef SIMPLE_FUNC
#undef INT_FUNC
#undef WIDGET_FUNC

JSGTK_CLASS(Container);

static JSFunctionSpec container_methods[] = {
    {"border_width",	container_set_border_width,		1},
    {"add",		container_add,			1},
    {"remove",		container_remove,		1},
    {"set_resize_mode",	container_set_resize_mode,	1},
    {"focus",		container_focus,		0},
    {0}
};

JSBool jsgtkbin_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkbutton_init(JSContext *cx, JSObject *global, JSObject *gtkproto);
JSBool jsgtkbox_init(JSContext *cx, JSObject *global, JSObject *gtkproto);

JSBool jsgtkcontainer_init(JSContext *cx, JSObject *global, JSObject *gtkproto) {
    JSObject *containerProto;

    containerProto = JS_InitClass(cx, global, gtkproto, &jsgtk_ContainerClass,
				  NULL, 0,
				  NULL, container_methods,
				  NULL, NULL);
    if (!containerProto ||
	!jsgtkbin_init(cx, global, containerProto) ||
	!jsgtkbutton_init(cx, global, containerProto) ||
	!jsgtkbox_init(cx, global, containerProto))
	return JS_FALSE;
    return JS_TRUE;
}
