#include "js-gtk.h"

JSGTK_CLASS(Editable);

static JSBool editable_select_region(JSContext *cx, JSObject *obj,
			     uintN argc, jsval *argv, jsval *rval) {  
  GtkEditable *editable;
  if (argc < 2 || !JSVAL_IS_INT(argv[0]) ||
      !JSVAL_IS_INT(argv[1]))
      return JS_FALSE;
  GET_GTK(editable,cx,obj,EDITABLE);
  gtk_editable_select_region(editable, JSVAL_TO_INT(argv[0]), JSVAL_TO_INT(argv[1]));
  return JS_TRUE;
}

static JSFunctionSpec editable_methods[] = {
    {"select_region", editable_select_region, 2},
    {0}
};

//JSObject *jsgtk_TextProto; 
JSObject * jsgtkeditable_init(JSContext *cx, JSObject *global, JSObject *gtkproto) { 
  JSObject  * editableProto;  
  editableProto = JS_InitClass(cx, global, gtkproto, &jsgtk_EditableClass, 
			       NULL,  0 , 
			       NULL,  editable_methods, 
			       NULL, NULL); 
  if (!editableProto) 
    return NULL;
  return editableProto;
}

