#include "js-gtk.h"

JSGTK_CLASS(List);

static JSBool list_ctor (JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *list;
         
    list = gtk_list_new();
    JS_SetPrivate(cx,obj, list);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(list), obj);
    return JS_TRUE;
}

static JSBool list_insert_items (JSContext *cx, JSObject *obj,
			 uintN argc, jsval *argv, jsval *rval) {
  GtkList *list;
  GtkWidget *list_item;
  GList *items = NULL;
  JSObject *ary;
  jsval ary_item;
  jsint length;
  jsint i;
  const gchar *list_item_data_key = "a data key";
  JSBool isAry;
  
  GET_GTK(list,cx,obj,LIST);  

  if (argc < 1 || !JSVAL_IS_OBJECT(argv[0]))
    return JS_FALSE;
  
  ary = JSVAL_TO_OBJECT(argv[0]);
  
  if (!JS_IsArrayObject(cx, ary))
    return JS_FALSE;
  
  if (!JS_GetArrayLength(cx, ary, &length))
    return JS_FALSE;
  
  
  for (i=0; i < length; i++) {
    if (!(JS_GetElement(cx, ary, i, &ary_item)))  {
      g_list_free(items);
      return JS_FALSE;
    }
    list_item=gtk_list_item_new_with_label(JS_GetStringBytes(JSVAL_TO_STRING(ary_item)));
/*    list_item=gtk_list_item_new_with_label(list_item_data_key);*/
    items=g_list_append(items, list_item);
    gtk_widget_show(list_item);
    gtk_object_set_data(GTK_OBJECT(list_item),
			list_item_data_key,
			"ListItem with integrated Label");
  }
  gtk_list_append_items(GTK_LIST(list), items);	
  return JS_TRUE;
}

static JSFunctionSpec list_methods[] = {
{"insert_items", list_insert_items, 1},
{0}
};

JSGTK_INIT_FUNC(list,List,0);
