#include "js-gtk.h"

JSGTK_CLASS(Pixmap);

static JSBool pixmap_ctor(JSContext *cx, JSObject *obj,
			  uintN argc, jsval *argv, jsval *rval) {
    GdkPixmap *pixmap;
    GtkStyle *style;
    GdkBitmap *mask;
    GtkWidget *parent;
    GtkWidget *widget;
    char *filename;

    if (argc < 2 ||
	!JSVAL_IS_STRING(argv[0]) ||
	!JSVAL_IS_OBJECT(argv[1]))
	return JS_FALSE;
    
    GET_GTK(parent,cx,JSVAL_TO_OBJECT(argv[1]),WIDGET);
    style = gtk_widget_get_style(parent);
    filename = JS_GetStringBytes(JSVAL_TO_STRING(argv[0]));
    pixmap = gdk_pixmap_create_from_xpm(NULL, &mask,
					&style->bg[GTK_STATE_NORMAL],
					filename);
    widget = gtk_pixmap_new(pixmap, mask);
    JS_SetPrivate(cx, obj, widget);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(widget), obj);
    return JS_TRUE;
}

#define pixmap_methods NULL
JSGTK_INIT_FUNC(pixmap,Pixmap,2);

