#include "js-gtk.h"

JSGTK_CLASS(Tooltips);

static JSBool tooltips_ctor(JSContext *cx, JSObject *obj,
			    uintN argc, jsval *argv, jsval *rval) {
    GtkTooltips *tooltips;
    
    tooltips = gtk_tooltips_new();
    JS_SetPrivate(cx, obj, tooltips);
    /* XXX need to fix gtk_{object,tooltips}_ref problem */
    /* jsgtkobj_registerWrapper(cx, GTK_OBJECT(tooltips), obj); */
    return JS_TRUE;
}

#define Widget Tooltips
#define SIMPLE_FUNC(funcname) \
  SIMPLE_WRAPPER_FUNC(tooltips,Tooltips,TOOLTIPS,funcname)
#define INT_FUNC(funcname) \
  INT_WRAPPER_FUNC(tooltips,Tooltips,TOOLTIPS,funcname)

#define GTK_IS_TOOLTIPS(x) 1
SIMPLE_FUNC(enable);
SIMPLE_FUNC(disable);
INT_FUNC(set_delay);
#undef GTK_IS_TOOLTIPS

#undef Widget
#undef SIMPLE_FUNC
#undef INT_FUNC

static JSBool tooltips_set_tips(JSContext *cx, JSObject *obj,
				uintN argc, jsval *argv, jsval *rval) {
    GtkTooltips *tooltips;
    GtkWidget *widget;
    
    if (argc < 2 ||
	!JSVAL_IS_OBJECT(argv[0]) ||
	!JSVAL_IS_STRING(argv[1]))
	return JS_FALSE;

#define GTK_IS_TOOLTIPS(x) 1
    GET_GTK(tooltips,cx,obj,TOOLTIPS);
#undef GTK_IS_TOOLTIPS
    GET_GTK(widget,cx,JSVAL_TO_OBJECT(argv[0]),WIDGET);
    gtk_tooltips_set_tip(tooltips, widget, JS_GetStringBytes(JSVAL_TO_STRING(argv[1])),"");
    return JS_TRUE;
}

static JSFunctionSpec tooltips_methods[] = {
    {"enable",		tooltips_enable,	0},
    {"disable",		tooltips_disable,	0},
    {"set_delay",	tooltips_set_delay,	1},
    {"set_tips",	tooltips_set_tips,	2},
    {0}
};

JSGTK_INIT_FUNC(tooltips,Tooltips,0);
