#include "js-gtk.h"

#define WIDGET_FUNC(funcname) \
  WIDGET_WRAPPER_FUNC(window,Window,WINDOW,funcname)
#define INT_FUNC(funcname) \
  INT_WRAPPER_FUNC(window,Window,WINDOW,funcname)

WIDGET_FUNC(set_focus)
WIDGET_FUNC(set_default)
INT_FUNC(position);

#undef WIDGET_FUNC
#undef INT_FUNC

static JSBool window_set_title(JSContext *cx, JSObject *obj,
			       uintN argc, jsval *argv, jsval *rval) {
    GtkWindow *window;
    
    if (!argc || !JSVAL_IS_STRING(argv[0]))
	return JS_FALSE;
    GET_GTK(window,cx,obj,WINDOW);
    gtk_window_set_title(window, JS_GetStringBytes(JSVAL_TO_STRING(argv[0])));
    return JS_TRUE;
}    

JSGTK_CLASS(Window);

static JSFunctionSpec window_methods[] = {
    {"set_focus",	window_set_focus,	1},
    {"set_default",	window_set_default,	1},
    {"position",	window_position,	1},
    {"set_title",	window_set_title,	1},
    {0}
};

static JSBool window_ctor(JSContext *cx, JSObject *obj,
			  uintN argc, jsval *argv, jsval *rval) {
    GtkWidget *window;

    if (argc < 1 ||
	!JSVAL_IS_INT(argv[0]) ||
	!JS_IsConstructing(cx))
	return JS_FALSE;

    window = gtk_window_new(JSVAL_TO_INT(argv[0]));
    if (!window)
	return JS_FALSE;
    JS_SetPrivate(cx, obj, window);
    jsgtkobj_registerWrapper(cx, GTK_OBJECT(window), obj);
    return JS_TRUE;
}

JSGTK_INIT_FUNC(window,Window,1);
